program PropertyDemo;

{$APPTYPE CONSOLE}

uses
  SysUtils, Classes, System.Reflection;

[assembly: AssemblyCopyright('Marco Cant')]

// a simple class with a property, to investigate property CLS mapping
type
  TMyClass = class
  public
    FOne, FTwo: string;
    procedure set_One(const Value: string);
    function GetTwo: string;
    procedure SetTwo(const Value: string);
  public
    property One: string read FOne write set_One;
  published
    property Two: string read GetTwo write SetTwo;
  end;

  TMySecondClass = class
  private
    strList: TStringList;
  public
    constructor Create;
    function get_One(I: Integer): string; overload;
    function get_One(Id: string): string; overload;
    function get_Two(Id: string): string;
    procedure set_One(I: Integer; const Value: string); overload;
    procedure set_One(Id: string; const Value: string); overload;
    procedure set_Two(Id: string; const Value: string);
  public
    property One [I: Integer]: string read get_One write set_One; default;
    property One [Id: string]: string read get_One write set_One; default;
    // property Two [Id: string]: string read get_Two write set_Two;
  end;


{ TMyClass }

function TMyClass.GetTwo: string;
begin
  Result := fTwo;
end;

procedure TMyClass.SetTwo(const Value: string);
begin
  fTwo := Value;
end;

procedure TMyClass.set_One(const Value: string);
begin
  FOne := Value;
end;

{ TMySecondClass }

constructor TMySecondClass.Create;
begin
  inherited Create;
  strList := TStringList.Create;
  strList.Add ('name=marco');
end;

function TMySecondClass.get_One(I: Integer): string;
begin
  Result := strList[I];
end;

function TMySecondClass.get_One(Id: &string): string;
begin
  Result := strList.Values [id];
end;

function TMySecondClass.get_Two(Id: &string): string;
begin
  Result := strList.Values [id];
end;

procedure TMySecondClass.set_One(I: Integer; const Value: &string);
begin
  strList [I] := Value;
end;

procedure TMySecondClass.set_One(Id: &string; const Value: &string);
begin
  strList.Values [id] := Value;
end;

procedure TMySecondClass.set_Two(Id: &string; const Value: &string);
begin
  strList.Values [id] := Value;
end;

var
  sc: TMySecondClass;

begin
  with TMyClass.Create do
  begin
    One := 'hello';
    Two := One;
    writeln (Two);
  end;

  sc := TMySecondClass.Create;
  sc ['text'] := 'hello';
  writeln (sc [0]);

  readln;
end.
